$("#refreshFeeds").bind("click", function(){
    getArticles('','1');
  });
$("#morearticles").live("click", function(){
	getArticles('',nextpagerequest);
	nextpagerequest++;
  });
 
function getArticles(count, page) {
	$.mobile.pageLoading();
	var script = document.createElement('script');
	script.src = 'http://www.berryreview.com/api/get_recent_posts/?callback=listEntries' + (page != 'all' ? '&page=' + page : '') ;
	document.body.appendChild(script);
}
 
// our Twitter API callback function
function listEntries(articles) {
  for (var i = 0; i < articles.posts.length; i++) {
    (function (article) {
      db.transaction(function (tx) {
        tx.executeSql('INSERT INTO brarticles VALUES (?, ?, ?, ?, ?, ?)', [article.id, article.title, article.date, article.content, article.comment_count, article.url]);
      });      
    })(articles.posts[i]);
  }
 
  show('all');
}
 
function show(amount) {
  db.transaction(function (tx) {
    tx.executeSql('SELECT * FROM brarticles LIMIT 100', [], function (tx, results) {
      var html = [];
      if (results.rows && results.rows.length) {
        for (var i = 0; i < results.rows.length; i++) {
          html.push('<li id="list' + i + '"><h2><a href="#singlearticle" id="' + results.rows.item(i).id + '" value="openarticle" style="white-space:normal;overflow:visible;">' + results.rows.item(i).title + '</a></h2><p class="ui-li-desc">' + fuzzyFacebookTime(results.rows.item(i).date + '+0000') + '</p> <span class="ui-li-count" id="commentCount' + i + '">' + results.rows.item(i).comment_count + '</span></li>');        }
		$('a[value|="openarticle"]').live('click', function(opensingle){
			showarticle(this.id);
		});
        $('#articleList').html(html.join(''));
		$("#articleList").listview("refresh");
      }
    });
  });
  $.mobile.pageLoading(1);
}
function showarticle(articleid) {
  db.transaction(function (tx) {
		tx.executeSql('SELECT * FROM brarticles WHERE id = ' + articleid + ' LIMIT 1', [], function (tx, results) {																						
			singledate = results.rows.item(0).date;
			$('#articleHeader1').text(results.rows.item(0).title);
			$('#articleContent1').replaceWith('<div id="articleContent1" class="articleContent">' + results.rows.item(0).content + '</div>');
			$('#openButton').attr('href', results.rows.item(0).url);
			
			tx.executeSql("SELECT id, date FROM brarticles WHERE date > '" + singledate + "' ORDER BY date LIMIT 1", [], function (tx, nextarticle) {																						
				//$('#nextButton').attr('href', function() { return '#singlearticle-' + results.rows.item(0).id });
				if (nextarticle.rows && nextarticle.rows.length){ 
					$('#nextButton').bind('click', function(opennext){
						showarticle(nextarticle.rows.item(0).id);
						$('#nextButton').unbind('click');
						$('#prevButton').unbind('click');
					});
				}
				else {
					$('#nextButton').unbind('click');
				};
			});
			
			tx.executeSql("SELECT id, date FROM brarticles WHERE date < '" + singledate + "' ORDER BY date DESC LIMIT 1", [], function (tx, prevarticle) {																						
				//$('#prevButton').attr('href', function() { return '#article' + results.rows.item(0).id });
				if (prevarticle.rows && prevarticle.rows.length){ 
					$('#prevButton').bind('click', function(openprev){
						showarticle(prevarticle.rows.item(0).id);
						$('#prevButton').unbind('click');
						$('#nextButton').unbind('click');
					});
				}
				else {
					$('#prevButton').unbind('click');
				}
			});
		});
	});
} 
 
function setupDatabase() {
  if (!window.openDatabase) {
    articlesEL.innerHTML = '<li>Web SQL Database API is required for this app to function and is not available in this browser, please try a BlackBerry 6 device. In the future we will work on a version for OS 5.0 devices but the WebKit browser is the future of BlackBerry web development.</li>';
    return;
  }
  db = openDatabase('brarticles', '1.0', 'db of BerryReview articles', 2 * 1024 * 1024);
  db.transaction(function (tx) {
    tx.executeSql('DROP TABLE IF EXISTS brarticles');
    tx.executeSql('CREATE TABLE IF NOT EXISTS brarticles (id unique, title, date, content, comment_count, url)');
  });
  getArticles('','all');
}

var fuzzyFacebookTime = (function(){

  fuzzyTime.defaultOptions={
    // time display options
    relativeTime : 48,
    // language options
    monthNames : ['Jan', 'Feb', 'Mar', 'Apr', 'May', 'Jun', 'Jul', 'Aug', 'Sep', 'Oct', 'Nov', 'Dec'],
    amPm : ['AM', 'PM'],
    ordinalSuffix : function(n) {return ['th','st','nd','rd'][n<4 || (n>20 && n % 10<4) ? n % 10 : 0]}
  }

  function fuzzyTime (timeValue, options) {

    var options=options||fuzzyTime.defaultOptions, 
        date=parseDate(timeValue),
        delta=parseInt(((new Date()).getTime()-date.getTime())/1000),
        relative=options.relativeTime,
        cutoff=+relative===relative ? relative*60*60 : Infinity;

    if (relative===false || delta>cutoff)
      return formatTime(date, options)+' '+formatDate(date, options);

    if (delta<60) return 'less than a minute ago';
    var minutes=parseInt(delta/60 +0.5);
    if (minutes <= 1) return 'about a minute ago';
    var hours=parseInt(minutes/60 +0.5);
    if (hours<1) return minutes+' minutes ago';
    if (hours==1) return 'about an hour ago';
    var days=parseInt(hours/24 +0.5);
    if (days<1) return hours+' hours ago';
    if (days==1) return formatTime(date, options)+' yesterday';
    var weeks=parseInt(days/7 +0.5);
    if (weeks<2) return formatTime(date, options)+' '+days+' days ago';
    var months=parseInt(weeks/4.34812141 +0.5);
    if (months<2) return weeks+' weeks ago';
    var years=parseInt(months/12 +0.5);
    if (years<2) return months+' months ago';
    return years+' years ago';
  }

  function parseDate (str) {
	var v=str.replace(/[\s\+]/g,' ').replace(/[-]/g,'/').split(' ');
    return new Date(Date.parse(v[0] + ", " + v[1] + " EST"));
  }

  function formatTime (date, options) {
    var h=date.getHours(), m=''+date.getMinutes(), am=options.amPm;
    return (h>12 ? h-12 : h)+':'+(m.length==1 ? '0' : '' )+m+' '+(h<12 ? am[0] : am[1]);
  }

  function formatDate (date, options) {
    var mon=options.monthNames[date.getMonth()],
        day=date.getDate(),
        year=date.getFullYear(),
        thisyear=(new Date()).getFullYear(),
        suf=options.ordinalSuffix(day);

    return mon+' '+day+suf+(thisyear!=year ? ', '+year : '');
  }

  return fuzzyTime;

}());